=== debian/changelog ===
mixxx (2.4.0+dfsg-2build4) noble; urgency=high

  * No change rebuild against libprotobuf-lite32t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:46:08 +0200

mixxx (2.4.0+dfsg-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:18:21 +0000

mixxx (2.4.0+dfsg-2build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:56:50 +0000

mixxx (2.4.0+dfsg-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:14:18 +0000

mixxx (2.4.0+dfsg-2) unstable; urgency=medium

  * Disable soundproxy_test because it fails on some architectures

 -- Dennis Braun <snd@debian.org>  Mon, 04 Mar 2024 20:16:47 +0100

mixxx (2.4.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.4.0+dfsg
    + Use the usual dfsg tag again
    + Exclude tools/windows_release_buildenv.bat too
  * d/control:
    + Update Build-Depends: Add googletest, libbenchmark-dev, libgmock-dev,
      libgtest-dev, libmsgsl-dev, qtdeclarative5-dev
    + Change B-D from pkg-config to pkgconf
  * d/copyright:
    + Refresh files
    + Bump years
  * Refresh *lintian-overrides
  * Refresh patchset
  * Use the default salsa CI/CD configuration

 -- Dennis Braun <snd@debian.org>  Fri, 23 Feb 2024 14:33:34 +0100
