=== debian/changelog ===
mixxx (2.4.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 02 Oct 2024 15:25:22 -0400

mixxx (2.4.1+dfsg-2~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Test build against new version of libdjinterop.
  * debian/patches/0006-Allow-libdjinterop-0.22.1.patch: Hardcode
    libdjinterop version to 0.22.1.

 -- Boyuan Yang <byang@debian.org>  Wed, 02 Oct 2024 11:26:36 -0400

mixxx (2.4.1+dfsg-1) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/TODO: Added

  [ Dennis Braun ]
  * New upstream version 2.4.1+dfsg
  * Bump Standards-Version to 4.7.0
  * Refresh patchset

 -- Dennis Braun <snd@debian.org>  Sun, 21 Jul 2024 10:38:25 +0200

mixxx (2.4.0+dfsg-3) unstable; urgency=high

  * Team upload.
  * debian/patches/0005-Allow-libdjinterop-0.21.0.patch: Add patch to allow
    libdjinterop 0.21.0.
  * debian/control:
    + Add missing build-dependency on libdjinterop-dev. (Closes: #1070492)
    + Remove hardcoded build-dependency on libvamp-*. Use the development
      package vamp-plugin-sdk instead to implicitly pull them in and to
      avoid the t64 library suffix problem.

 -- Boyuan Yang <byang@debian.org>  Fri, 12 Jul 2024 17:10:10 -0400
