=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mixxx
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Paul Brossier <piem@debian.org>,
  Free Ekanayaka <freee@debian.org>,
@@ -18,6 +17,8 @@
  libavformat-dev,
  libbenchmark-dev,
  libchromaprint-dev,
+ libdjinterop-dev (>= 0.22.1~),
+ libdjinterop-dev (<< 0.22.2~),
  libebur128-dev,
  libexpat-dev,
  libfaad-dev,
@@ -55,8 +56,6 @@
  libtag1-dev,
  libupower-glib-dev,
  libusb-1.0-0-dev,
- libvamp-hostsdk3v5,
- libvamp-sdk2v5,
  libvorbis-dev,
  libwavpack-dev,
  pkgconf,
@@ -67,7 +66,7 @@
  qtscript5-dev,
  vamp-plugin-sdk,
  xvfb
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/mixxx.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mixxx
