## mixxx 2.5.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.16)
+cmake_minimum_required(VERSION 3.21)
 
 message(STATUS "CMAKE_VERSION: ${CMAKE_VERSION}")
 
@@ -54,14 +54,18 @@
     else()
       message(FATAL_ERROR "Did you download the Mixxx build environment using `${CMAKE_SOURCE_DIR}/tools/windows_release_buildenv.bat` or `${CMAKE_SOURCE_DIR}/tools/windows_buildenv.bat`(includes Debug)?")
     endif()
-  elseif(APPLE)
+  elseif(APPLE AND NOT IOS)
     if(CMAKE_BUILD_TYPE MATCHES "Debug")
       message(FATAL_ERROR "Did you download the Mixxx build environment using `${CMAKE_SOURCE_DIR}/tools/macos_buildenv.sh`")
     else()
       message(FATAL_ERROR "Did you download the Mixxx build environment using `${CMAKE_SOURCE_DIR}/tools/macos_release_buildenv.sh` or `${CMAKE_SOURCE_DIR}/tools/macos_buildenv.sh`(includes Debug)?")
     endif()
-  else()
+  elseif(LINUX)
     message(FATAL_ERROR "Did you install the Debian dev packages via `${CMAKE_SOURCE_DIR}/tools/debian_buildenv.sh` or the equivalent packages using your package manager?")
+  elseif(DEFINED VCPKG_TARGET_TRIPLET)
+    message(FATAL_ERROR "You are targeting ${VCPKG_TARGET_TRIPLET}, which does not have a prebuilt environment. Please make sure that -DMIXXX_VCPKG_ROOT points to a vcpkg environment containing installed dependencies for ${VCPKG_TARGET_TRIPLET}!")
+  else()
+    message(FATAL_ERROR "You are building for an unknown platform and are missing a build environment. Please set -DVCPKG_TARGET_TRIPLET and make sure that -DMIXXX_VCPKG_ROOT points to a vcpkg environment containing installed dependencies for your target platform!")
   endif()
 endfunction()
 
@@ -133,23 +137,36 @@
   endif()
 endif()
 
-option(QT6 "Build with Qt6" OFF)
-if(QT6)
-  if (DEFINED ENV{GITHUB_ACTIONS})
-    message("Running experimental Qt6 build for GitHub Actions")
-  else()
-    message(FATAL_ERROR
-        "Mixxx 2.4 does not fully support Qt6, use 2.5/main instead. "
-        "Qt6 support is available for CI checks only and requires the environment variable GITHUB_ACTIONS to be set.")
-  endif()
-endif()
-
+include(CMakeDependentOption)
+
+option(QT6 "Build with Qt6" ON)
+cmake_dependent_option(QML "Build with QML" ON "QT6" OFF)
 option(QOPENGL "Use QOpenGLWindow based widget instead of QGLWidget" ON)
+
 if(QOPENGL)
   add_compile_definitions(MIXXX_USE_QOPENGL)
 endif()
 
-if(APPLE)
+if(QML)
+  add_compile_definitions(MIXXX_USE_QML)
+endif()
+
+if(VCPKG_TARGET_TRIPLET MATCHES "^wasm(32|64)-emscripten")
+  message(STATUS "Targeting Emscripten (${VCPKG_TARGET_TRIPLET})")
+  if(DEFINED ENV{EMSDK})
+    message(STATUS "Found EMSDK at $ENV{EMSDK}")
+  else()
+    message(FATAL_ERROR "Please make sure emsdk is installed and the environment variable EMSDK is set (see https://emscripten.org/docs/getting_started/downloads.html)")
+  endif()
+  if(NOT DEFINED VCPKG_CHAINLOAD_TOOLCHAIN_FILE)
+    set(VCPKG_CHAINLOAD_TOOLCHAIN_FILE "$ENV{EMSDK}/upstream/emscripten/cmake/Modules/Platform/Emscripten.cmake" CACHE STRING "")
+  endif()
+  # Enabling this causes Qt's FindWrapRt C++ compile check to fail as it tries
+  # to run `clang-scan-deps` (because we set the C++ standard to 20). Emscripten
+  # does not ship this binary yet, though. Potentially relevant upstream bug:
+  # https://github.com/emscripten-core/emscripten/issues/21042
+  set(CMAKE_CXX_SCAN_FOR_MODULES OFF)
+elseif(APPLE)
   # Check if xcode-select is installed
   execute_process(COMMAND xcode-select -v
     RESULT_VARIABLE XCODE_SELECT_RESULT
@@ -160,32 +177,35 @@
     message(FATAL_ERROR "'xcode-select -v' failed with '${XCODE_SELECT_RESULT}'. You may need to install Xcode and run 'sudo xcode-select --install'.")
   endif()
 
-  if(QT6)
-    # Minimum macOS version supported by Qt 6
-    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Minimum macOS version the build will be able to run on")
-    if(NOT VCPKG_TARGET_TRIPLET)
-      set(VCPKG_TARGET_TRIPLET "x64-osx-min1015")
-    endif()
-  else()
-    if(VCPKG_TARGET_TRIPLET MATCHES "arm64-osx-min1100")
+  if(VCPKG_TARGET_TRIPLET MATCHES "^[a-zA-Z0-9]+-osx")
+    message(STATUS "Targeting macOS (${VCPKG_TARGET_TRIPLET})")
+    set(CMAKE_SYSTEM_NAME Darwin CACHE STRING "Target macOS")
+    if(VCPKG_TARGET_TRIPLET MATCHES "^arm64-")
       # Minimum macOS version for arm64 Support
       set(CMAKE_OSX_DEPLOYMENT_TARGET 11.0 CACHE STRING "Minimum macOS version the build will be able to run on")
-      set(CMAKE_OSX_ARCHITECTURES arm64 CACHE STRING "The target achritecture")
+      set(CMAKE_OSX_ARCHITECTURES arm64 CACHE STRING "The target architecture")
       set(CMAKE_SYSTEM_PROCESSOR arm64 CACHE STRING "The target system processor")
-      set(CMAKE_SYSTEM_NAME Darwin CACHE STRING "Setting this enables CMAKE_CROSSCOMPILE")
     else()
-      # Minimum macOS version supported by Qt 5.12
-      set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "Minimum macOS version the build will be able to run on")
-      if(NOT VCPKG_TARGET_TRIPLET)
-        set(VCPKG_TARGET_TRIPLET "x64-osx-min1012")
+      if(QT6)
+        # Minimum macOS version supported by Qt 6
+        set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Minimum macOS version the build will be able to run on")
+      else()
+        # Minimum macOS version supported by Qt 5.12
+        set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "Minimum macOS version the build will be able to run on")
+        # Needed for deployment target < 10.14
+        add_compile_options(-fno-aligned-allocation)
       endif()
-      # Needed for deployment target < 10.14
-      add_compile_options(-fno-aligned-allocation)
-    endif()
-  endif()
-endif()
-
-project(mixxx VERSION 2.4.1)
+    endif()
+  elseif(VCPKG_TARGET_TRIPLET MATCHES "^[a-zA-Z0-9]+-ios")
+    message(STATUS "Targeting iOS (${VCPKG_TARGET_TRIPLET})")
+    set(CMAKE_SYSTEM_NAME iOS CACHE STRING "Target iOS")
+    set(CMAKE_OSX_DEPLOYMENT_TARGET 14.0 CACHE STRING "Minimum iOS version to target")
+  else()
+    message(WARNING "Targeting an Apple platform, but VCPKG_TARGET_TRIPLET is not set. This is not a supported scenario!")
+  endif()
+endif()
+
+project(mixxx VERSION 2.5.0)
 enable_language(C CXX)
 # Work around missing version suffixes support https://gitlab.kitware.com/cmake/cmake/-/issues/16716
 set(MIXXX_VERSION_PRERELEASE "") # set to "alpha" "beta" or ""
@@ -197,7 +217,6 @@
 set(BUILD_COLORS "auto" CACHE STRING "Try to use colors auto/always/no")
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
-include(CMakeDependentOption)
 include(CheckSymbolExists)
 include(CheckIncludeFileCXX)
 include(ExternalProject)
@@ -270,44 +289,3 @@
 # for all other compilers.
 cmake_dependent_option(COVERAGE "Coverage (i.e. gcov) support" OFF "GNU_GCC" OFF)
 if(COVERAGE)
-  add_compile_options(--coverage -fprofile-arcs -ftest-coverage)
-  add_link_options(--coverage -fprofile-arcs -ftest-coverage)
-endif()
-
-# Profiling
-#
-# This is only available on Linux, therefore this option is forcibly set to OFF
-# on all other platforms.
-cmake_dependent_option(PROFILING "Profiling (e.g. gprof) support" OFF "UNIX;NOT APPLE" OFF)
-if(PROFILING)
-  add_compile_options(-pg)
-  add_link_options(-pg)
-endif()
-
-#
-# Optimizations
-#
-
-set(OPTIMIZE "portable" CACHE STRING "Optimization and Tuning (set to off, portable, native, legacy)")
-set_property(CACHE OPTIMIZE PROPERTY STRINGS "off" "portable" "native" "legacy")
-string(TOLOWER "${OPTIMIZE}" OPTIMIZE)
-message(STATUS "Optimization level: ${OPTIMIZE}")
-
-# CMAKE_INTERPROCEDURAL_OPTIMIZATION can be defined to override the default behaviour.
-# We keep CMAKE_INTERPROCEDURAL_OPTIMIZATION unset (IPO disabled) to save
-# build time at the cost of a bigger memory footprint at run-time.
-# See https://github.com/mixxxdj/mixxx/pull/3589 for some test results
-# Note: IPO has caused issues on Fedora https://bugzilla.rpmfusion.org/show_bug.cgi?id=5829
-# Uncomment the following code to enable IPO for Release builds
-#if(NOT DEFINED CMAKE_INTERPROCEDURAL_OPTIMIZATION AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT OPTIMIZE STREQUAL "off")
-#  include(CheckIPOSupported)
-#  check_ipo_supported(RESULT HAVE_IPO)
-#  if(HAVE_IPO)
-#    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
-#  endif()
-#endif()
-
-if(MSVC)
-  # Microsoft Visual Studio Compiler
-  add_compile_options(/UTF8)
-  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
