=== debian/changelog ===
mixxx (2.5.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * debian/control: Use build-dependency package for taglib 2.x:
    libtag1-dev => libtag-dev.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 Jan 2025 05:30:13 -0500

mixxx (2.5.0+dfsg-2) unstable; urgency=medium

  * Fix missing dependency libqt6sql6-sqlite (Closes: #1092219)

 -- Dennis Braun <snd@debian.org>  Tue, 07 Jan 2025 19:36:05 +0100

mixxx (2.5.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.0+dfsg
  * Build with Qt6
  * Refresh Files-Excluded
  * Refresh patchset and drop libdjinterop patch applied by upstream
  * Workaround to fix broken Mixxx GUI on wayland, by adding '-platform xcb'
    for the exec of the desktop file (Closes: #1039859)
  * Apply wrap-and-sort -ast

 -- Dennis Braun <snd@debian.org>  Tue, 31 Dec 2024 14:56:38 +0100
