=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Paul Brossier <piem@debian.org>,
  Free Ekanayaka <freee@debian.org>,
- Dennis Braun <snd@debian.org>
+ Dennis Braun <snd@debian.org>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -17,8 +17,8 @@
  libavformat-dev,
  libbenchmark-dev,
  libchromaprint-dev,
+ libdjinterop-dev (<< 0.22.2~),
  libdjinterop-dev (>= 0.22.1~),
- libdjinterop-dev (<< 0.22.2~),
  libebur128-dev,
  libexpat-dev,
  libfaad-dev,
@@ -42,18 +42,17 @@
  libopusfile-dev,
  libportmidi-dev [linux-any],
  libprotobuf-dev,
- libqt5opengl5-dev,
- libqt5sql5-sqlite,
- libqt5svg5-dev,
- libqt5x11extras5-dev,
- libqt5xmlpatterns5-dev,
+ libqt6core5compat6-dev,
+ libqt6opengl6-dev,
+ libqt6sql6-sqlite,
+ libqt6svg6-dev,
  librubberband-dev,
  libshout-idjc-dev,
  libsndfile1-dev,
  libsoundtouch-dev,
  libsqlite3-dev,
  libssl-dev,
- libtag1-dev,
+ libtag-dev,
  libupower-glib-dev,
  libusb-1.0-0-dev,
  libvorbis-dev,
@@ -61,11 +60,22 @@
  pkgconf,
  portaudio19-dev,
  protobuf-compiler,
- qt5keychain-dev,
- qtdeclarative5-dev,
- qtscript5-dev,
+ qml6-module-qt-labs-qmlmodels,
+ qml6-module-qt5compat-graphicaleffects,
+ qml6-module-qtqml-workerscript,
+ qml6-module-qtquick-controls,
+ qml6-module-qtquick-layouts,
+ qml6-module-qtquick-nativestyle,
+ qml6-module-qtquick-shapes,
+ qml6-module-qtquick-templates,
+ qml6-module-qtquick-window,
+ qt6-base-private-dev,
+ qt6-declarative-private-dev,
+ qt6-qpa-plugins,
+ qt6-shadertools-dev,
+ qtkeychain-qt6-dev,
  vamp-plugin-sdk,
- xvfb
+ xvfb,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/mixxx.git
@@ -75,11 +85,12 @@
 Package: mixxx
 Architecture: linux-any
 Depends:
- libqt5sql5-sqlite,
+ libqt6sql6-sqlite,
  mixxx-data (= ${source:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
-Suggests: pdf-viewer
+ ${shlibs:Depends},
+Suggests:
+ pdf-viewer,
 Description: Digital Disc Jockey Interface
  Mixxx is a digital DJ system, where Wave, Ogg, FLAC and MP3 files can be
  mixed on a computer for use in live performances. Filters, crossfader, and
@@ -92,7 +103,8 @@
 Package: mixxx-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: Digital Disc Jockey Interface -- data files
  Mixxx is a digital DJ system, where Wave, Ogg, FLAC and MP3 files can be
  mixed on a computer for use in live performances. Filters, crossfader, and
