=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export QT_SELECT=5
+export QT_SELECT=6
 
 CMAKE_OPTS = -DCMAKE_BUILD_TYPE=Release \
 		-DINSTALL_USER_UDEV_RULES=OFF \
